@version 2.8
@script generic
@warnings
@name Save BONE object...


generic
{
    // Create a Mesh Object from first object loaded.
    mesh = Mesh() || error("No Object Loaded!");

    SCM=mesh;

    objDir = getdir("Objects");

    if((getSCMFile = getfile("Save BONE...","*.bscm",objDir)) == nil)
        return;

    if((scmFile = File(getSCMFile,"wb+")) == nil)
    {
        error("Unable to open target file.");
        return;
    }
    
    bone=SCM.bone();
    n=0;
    w=0;
    while(bone){
    if(bone.flags[1]){
    n++;
    //info(bone.flags[1]," ",n," ",w);
    bones[n]=bone;
    bonename[n]=bone.name;
    bonewpos[n]=bone.getWorldPosition(0);
    bonewrot[n]=bone.getWorldRotation(0);    
    boneparent[n]=bone.parent.name;
    bonerot[n]=bone.getRotation(0);
    bonepos[n]=bone.getPosition(0);
    w++;
    }
    bone=bone.next();
    }

    bone=SCM.bone();
    while(bone){
    if(!bone.flags[1]){
    n++;
    //info(bone.flags[1]," ",n," ",w);
    bones[n]=bone;
    bonename[n]=bone.name;
    bonewpos[n]=bone.getWorldPosition(0);
    bonewrot[n]=bone.getWorldRotation(0);    
    boneparent[n]=bone.parent.name;
    bonerot[n]=bone.getRotation(0);
    bonepos[n]=bone.getPosition(0);
    }
    bone=bone.next();   
    }

    bonecount=n;   
    wbonecount=w;
    
    scmFile.writeInt(bonecount);
    scmFile.writeInt(wbonecount);

    writeLine(scmFile,"NAME");
    writeLine(scmFile,bonename[1]);
    scmFile.writeByte(0);
    for(b=2;b<=bonecount;b++){
    writeLine(scmFile,bonename[b]);
    scmFile.writeByte(0);}
    writeLine(scmFile,"SKEL");
    for(b=1;b<=bonecount;b++){
    writeFloat(scmFile,element(bonewpos[b],1));
    writeFloat(scmFile,element(bonewpos[b],2));
    writeFloat(scmFile,element(bonewpos[b],3));
    while(element(bonewrot[b],1)>180){bonewrot[b]=<element(bonewrot[b],1)+-360,element(bonewrot[b],2),element(bonewrot[b],3)>;}
    while(element(bonewrot[b],1)<-180){bonewrot[b]=<element(bonewrot[b],1)+360,element(bonewrot[b],2),element(bonewrot[b],3)>;}
    while(element(bonewrot[b],2)>180){bonewrot[b]=<element(bonewrot[b],1),element(bonewrot[b],2)+-360,element(bonewrot[b],3)>;}
    while(element(bonewrot[b],2)<-180){bonewrot[b]=<element(bonewrot[b],1),element(bonewrot[b],2)+360,element(bonewrot[b],3)>;}
    while(element(bonewrot[b],3)>180){bonewrot[b]=<element(bonewrot[b],1),element(bonewrot[b],2),element(bonewrot[b],3)+-360>;}
    while(element(bonewrot[b],3)<-180){bonewrot[b]=<element(bonewrot[b],1),element(bonewrot[b],2),element(bonewrot[b],3)+360>;}
    writeFloat(scmFile,element(bonewrot[b],1));
    writeFloat(scmFile,element(bonewrot[b],2));
    writeFloat(scmFile,element(bonewrot[b],3));

    writeFloat(scmFile,element(bonepos[b],1));
    writeFloat(scmFile,element(bonepos[b],2));
    writeFloat(scmFile,element(bonepos[b],3));

    while(element(bonerot[b],1)>180){bonerot[b]=<element(bonerot[b],1)+-360,element(bonerot[b],2),element(bonerot[b],3)>;}
    while(element(bonerot[b],1)<-180){bonerot[b]=<element(bonerot[b],1)+360,element(bonerot[b],2),element(bonerot[b],3)>;}
    while(element(bonerot[b],2)>180){bonerot[b]=<element(bonerot[b],1),element(bonerot[b],2)+-360,element(bonerot[b],3)>;}
    while(element(bonerot[b],2)<-180){bonerot[b]=<element(bonerot[b],1),element(bonerot[b],2)+360,element(bonerot[b],3)>;}
    while(element(bonerot[b],3)>180){bonerot[b]=<element(bonerot[b],1),element(bonerot[b],2),element(bonerot[b],3)+-360>;}
    while(element(bonerot[b],3)<-180){bonerot[b]=<element(bonerot[b],1),element(bonerot[b],2),element(bonerot[b],3)+360>;}
    writeFloat(scmFile,element(bonerot[b],1));
    writeFloat(scmFile,element(bonerot[b],2));
    writeFloat(scmFile,element(bonerot[b],3));
    scmFile.writeInt(bonename.indexOf(boneparent[b]));
    }
    scmFile.close();
}

writeLine: file, string
{
for(m=1;m<=size(string);m++){
file.writeByte(ascii(strsub(string,m,1)));
}
}

element: vector, position
{
val=parse(" ",vector.asStr());
return(number(val[position]));
}

writeFloat: file, float
{
/*Here's where it gets complicated. We need to write the float number as an integer comprised of binary data that would
make a proper float. According to the wiki, here's what we do.
We take the sign, and set the first bit as that - 0 for plus, 1 for minus.
Next we convert the number into binary. The integer part is easy, since the binary function works that.
The fraction part is trickier, but doable - we need to double it to see if we get a 1 or more, and write 1 for that, 
removing the integer for the next cycle, or write 0 otherwise and move on until we either get a 0 remaining
or the size of the binary string with the integer part hits 24. Then we exponentize the result, and write the 8-bit binary of 127+exponent,
then pad the remaining binary string with zeroes to size 23, and write it too. We should get a binary string that, made into an
integer, should write as a perfect float.*/
sign="";
exponent="";
fraction="";
fracts="";
fract="";
intgr="";
if(float>=0){sign="0";}else{sign="1";}
float=abs(float);
fract=frac(float);
intgr=integer(float-fract);
intbin=binary(intgr);
fractbin=fracbin(intbin,fract);
expt=intbin.size()-fractbin.indexOf('1');
if(float==0){expt=-127;}
exponent=binary(expt+127,8);
if(fractbin.indexOf('1')>0){while(strleft(fractbin,1)=="0"){fractbin=strright(fractbin,fractbin.size()+(-1));}}
fraction=strright(fractbin,fractbin.size()+(-1)); //funky coding to reduce leading zeroes, cut one leading "1", and shape the result.
fraction=strleft(fraction,23);
for(i=3;i>=0;i--){
file.writeByte(integer("0b"+strsub(sign+exponent+fraction,(8*i)+1,8)));
}
}

fracbin: bint,float //function for getting the binary representation of the float-point fraction
{
bins=bint;
while(bins.size()<64)
{
v1=float*2;
if(v1>=1){bins+="1";float=frac(v1);}else{bins+="0";float=v1;}
}
return bins; //Returned is the binary representation of the total fraction section of the initial number
}

quater: h,p,b
{
wxyz[1]=0;
wxyz[2]=0;
wxyz[3]=0;
wxyz[4]=0;
c1 = cos(h / 2);
c2 = cos(p / 2);
c3 = cos(b / 2);
s1 = sin(h / 2);
s2 = sin(p / 2);
s3 = sin(b / 2);
c1c2=c1*c2;
s1s2=s1*s2;
wxyz[1]= c1*c2*c3 +- s1*s2*s3;
wxyz[2]= s1*s2*c3 + c1*c2*s3;
wxyz[3]= s1*c2*c3 + c1*s2*s3;
wxyz[4]= c1*s2*c3 +- s1*c2*s3;
return wxyz;
}






























