@version 2.8
@script generic
@warnings
@name Save SCA Animation...


generic
{
    // Create a Mesh Object from first object loaded.
    mesh = Mesh() || error("No Object Loaded!");

    SCM=mesh;
    scene=Scene();

    objDir = getdir("Objects");

    if((getSCAFile = getfile("Save SCA...","*.sca",objDir)) == nil)
        return;

    if((scafile = File(getSCAFile,"wb+")) == nil)
    {
        error("Unable to open target file.");
        return;
    }
    
    bone=SCM.bone();
    n=0;
    w=0;
    while(bone){
    if(bone.flags[1]){
    n++;
    //info(bone.flags[1]," ",n," ",w);
    bones[n]=bone;
    wbones[n]=bone;
    bonename[n]=bone.name;
    bonewpos[n]=bone.getWorldPosition(0);
    bonewrot[n]=bone.getWorldRotation(0);    
    boneparent[n]=bone.parent.name;
    bonerot[n]=bone.getRotation(0);
    bonepos[n]=bone.getPosition(0);
    w++;
    }
    bone=bone.next();
    }
    activebones[1]=0;
    bone=SCM.bone();
    while(bone){
    if(!bone.flags[1]){
    n++;
    //info(bone.flags[1]," ",n," ",w);
    bones[n]=bone;
    bonename[n]=bone.name;
    bonewpos[n]=bone.getWorldPosition(0);
    bonewrot[n]=bone.getWorldRotation(0);    
    boneparent[n]=bone.parent.name;
    bonerot[n]=bone.getRotation(0);
    bonepos[n]=bone.getPosition(0);
    }
    bone=bone.next();   
    }

    f=0; //// Get all bones that have explicit keyframes.
    foreach(b,wbones){
    chan=b.firstChannel();
    if(chan.keyCount>1)
    {
    f++;
    activebones[f]=b;
    activenames[f]=b.name;
    }
    }

/*    //// Get all bones that have a goal, and all IK-marked parent bones of that.
    foreach(b,wbones){
    ac=0;
    if(b.goal || b.flags[2]){ac=1;}
    if(ac)
    {
    f++;
    activebones[f]=b;
    activenames[f]=b.name;
    }}*/                    //Actually no, scrap that. IK messes with rotation channels, and we need to keyframe everything so it can work.
    bonecount=n;   
    wbonecount=w;
    animbonecount=activebones.size();

    scafile.writeInt(0); //x9 for header pre-padding;
    scafile.writeInt(0); //version
    scafile.writeInt(0); //number of frames
    scafile.writeInt(0); //anim length
    scafile.writeInt(0); //active bonenumber
    scafile.writeInt(0); //bone name offset
    scafile.writeInt(0); //bonelink offset
    scafile.writeInt(0); //anim data offset
    scafile.writeInt(0); //bytes per frame (4+3)*4*bonenumber

////
//// BONE NAMES ///////////////////////////////////////////
////

    writeLine(scafile,"NAME");
    nameoff=scafile.offset();
    foreach(n,activebones){
    writeLine(scafile,n.name);
    scafile.writeByte(0);
    }
    
    while(mod(scafile.offset(),32)!=28){scafile.writeByte(162);} //pad

////
//// LINK DATA (parents) //////////////////////////////////
////

    writeLine(scafile,"LINK");
    linkoff=scafile.offset();
    foreach(n,activebones){
//    info(bonename.indexOf(n.parent.name)+-1);
    scafile.writeInt(bonename.indexOf(n.parent.name)+-1);
    }

    while(mod(scafile.offset(),32)!=28){scafile.writeByte(162);} //pad

////
//// DATA SECTION (keyframes) /////////////////////////////
////


    writeLine(scafile,"DATA");
    dataoff=scafile.offset();
    //Position delta of the root object, i.e the first object;
    deltapos=<0,0,0>; //mesh.getWorldPosition(scene.previewend)+-mesh.getWorldPosition(scene.previewstart);
    deltarot=<0,0,0>; //mesh.getWorldRotation(scene.previewend)+-mesh.getWorldRotation(scene.previewstart);
    deltarot2=quater(rad(element(deltarot,1)),rad(element(deltarot,2)),rad(element(deltarot,3)));
    writeFloat(scafile,element(deltapos,1));
    writeFloat(scafile,element(deltapos,2));
    writeFloat(scafile,element(deltapos,3));
    writeFloat(scafile,deltarot2[1]);
    writeFloat(scafile,deltarot2[2]);
    writeFloat(scafile,deltarot2[3]);
    writeFloat(scafile,deltarot2[4]);

for(d=scene.previewstart;d<=scene.previewend;d++)
{
writeFloat(scafile,d+-scene.previewstart/scene.fps); // I presume the time is THE time. Not the length of the frame.
scafile.writeInt(0);
t=d/scene.fps;
foreach(b,activebones)
{
writeFloat(scafile,element(b.getPosition(t),1)*(-1));
writeFloat(scafile,element(b.getPosition(t),2)*(1));
writeFloat(scafile,element(b.getPosition(t),3)*(1));
rotr=quater( rad(element(b.getRotation(t),1)*(-1)) , rad(element(b.getRotation(t),3)*(-1)) , rad(element(b.getRotation(t),2)*(1)) );
writeFloat(scafile,rotr[1]);
writeFloat(scafile,rotr[2]);
writeFloat(scafile,rotr[3]);
writeFloat(scafile,rotr[4]);
}
}

scafile.offset(0); //return to beginning to write header

    writeLine(scafile,"ANIM"); //header
    scafile.writeInt(5); //version
    scafile.writeInt(scene.previewend-scene.previewstart+1); //number of frames
    writeFloat(scafile,(scene.previewend-scene.previewstart+1)/scene.fps); //anim length
    scafile.writeInt(animbonecount); //active bonenumber
    scafile.writeInt(nameoff); //bone name offset
    scafile.writeInt(linkoff); //bonelink offset
    scafile.writeInt(dataoff); //anim data offset
    scafile.writeInt(8+(28*animbonecount)); //bytes per frame 8+(7*4*bonenumber)


    scafile.close();
}

writeLine: file, string
{
for(m=1;m<=size(string);m++){
file.writeByte(ascii(strsub(string,m,1)));
}
}

element: vector, position
{
val=parse(" ",vector.asStr());
return(number(val[position]));
}

writeFloat: file, float
{
/*Here's where it gets complicated. We need to write the float number as an integer comprised of binary data that would
make a proper float. According to the wiki, here's what we do.
We take the sign, and set the first bit as that - 0 for plus, 1 for minus.
Next we convert the number into binary. The integer part is easy, since the binary function works that.
The fraction part is trickier, but doable - we need to double it to see if we get a 1 or more, and write 1 for that, 
removing the integer for the next cycle, or write 0 otherwise and move on until we either get a 0 remaining
or the size of the binary string with the integer part hits 24. Then we exponentize the result, and write the 8-bit binary of 127+exponent,
then pad the remaining binary string with zeroes to size 23, and write it too. We should get a binary string that, made into an
integer, should write as a perfect float.*/
sign="";
exponent="";
fraction="";
fracts="";
fract="";
intgr="";
if(float>=0){sign="0";}else{sign="1";}
float=abs(float);
fract=frac(float);
intgr=integer(float-fract);
intbin=binary(intgr);
fractbin=fracbin(intbin,fract);
expt=intbin.size()-fractbin.indexOf('1');
if(float==0){expt=-127;}
exponent=binary(expt+127,8);
if(fractbin.indexOf('1')>0){while(strleft(fractbin,1)=="0"){fractbin=strright(fractbin,fractbin.size()+(-1));}}
fraction=strright(fractbin,fractbin.size()+(-1)); //funky coding to reduce leading zeroes, cut one leading "1", and shape the result.
fraction=strleft(fraction,23);
for(i=3;i>=0;i--){
file.writeByte(integer("0b"+strsub(sign+exponent+fraction,(8*i)+1,8)));
}
}

fracbin: bint,float //function for getting the binary representation of the float-point fraction
{
bins=bint;
while(bins.size()<64)
{
v1=float*2;
if(v1>=1){bins+="1";float=frac(v1);}else{bins+="0";float=v1;}
}
return bins; //Returned is the binary representation of the total fraction section of the initial number
}

quater: h,p,b
{
wxyz[1]=0;
wxyz[2]=0;
wxyz[3]=0;
wxyz[4]=0;
c1 = cos(h / 2);
c2 = cos(p / 2);
c3 = cos(b / 2);
s1 = sin(h / 2);
s2 = sin(p / 2);
s3 = sin(b / 2);
c1c2=c1*c2;
s1s2=s1*s2;
wxyz[1]= c1*c2*c3 +- s1*s2*s3;
wxyz[2]= s1*s2*c3 + c1*c2*s3;
wxyz[3]= s1*c2*c3 + c1*s2*s3;
wxyz[4]= c1*s2*c3 +- s1*c2*s3;
return wxyz;
}

atan2: y, x
{
    coeff1 = 3.14159265358 / 4;
    coeff2 = 3 * coeff1;
    abs_y = abs(y);
    angle=0.0;
    if(x >= 0)
 {
        r = (x - abs_y) / (x + abs_y);
        angle = coeff1 - coeff1 * r;
    } else {
        r = (x + abs_y) / (abs_y - x);
        angle = coeff2 - coeff1 * r;
    }
   if(y<0){angle=angle*(-1);}
    return angle;
}

euler: quat
{
w=quat[1];
x=quat[2];
y=quat[3];
z=quat[4];
xyz[1]=0;
xyz[2]=0;
xyz[3]=0;

xyz[1] = atan2(2*y*w+-2*x*z , 1 +-(2*y^^2) +- (2*z^^2));
xyz[3] = atan2(2*x*w+-2*y*z , 1 +-(2*x^^2) +- (2*z^^2));

if(x*y + z*w==0.5)
{ // (north pole)
xyz[1] = 2 * atan2(x,w);
xyz[3] = 0;}
if(x*y + z*w==(-0.5))
{ // (south pole)
xyz[1] = -2 * atan2(x,w);
xyz[3] = 0 ;
}

xyz[2] = asin(2*x*y + 2*z*w);
return xyz;
}



































