@version 2.8
@script modeler
@warnings
@name Save SCM Object...


main
{
    
selmode(USER);
selpolygon(SET);
mirror(X,0);
delete();
selmode(GLOBAL);

    editbegin();
    ttlPnts = pointcount();

    tmap = VMap(VMTEXTURE);

    wmap=VMap(VMWEIGHT);

    if(!ttlPnts)
    {
        error("<br>You must have geometry to perform this operation");
        return;
    }
    
    objDir = getdir("Objects");

    if((getSCMFile = getfile("Save SCM...","*.scm",objDir)) == nil)
        return;

    if((scmFile = File(getSCMFile,"wb+")) == nil)
    {
        error("Unable to open target file.");
        return;
    }
    if((getboneFile = getfile("Select bone file...","*.bscm",objDir,1)) == nil)
        return;

    if((bonefile = File(getboneFile,"rb+")) == nil)
    {
        error("Unable to open target file.");
        return;
    }    

    bonecount=bonefile.readInt();
    wbonecount=bonefile.readInt();

    monamount=bonecount*20+pointcount()*10+polygons.size()*5+20;
    moninit(monamount,"Let's see what we can see...");

    bonefile.readInt();
    for(r=1;r<=bonecount;r++){
    bonenames[r]=getname(bonefile);}
    bonefile.readInt();
    for(r=1;r<=bonecount;r++){
    bonewpos[r]=<bonefile.readNumber()*(-1),bonefile.readNumber(),bonefile.readNumber()>;
    bonewrot[r]=<bonefile.readNumber()*(-1),bonefile.readNumber(),bonefile.readNumber()>;
    bonepos[r]=<bonefile.readNumber()*(-1),bonefile.readNumber(),bonefile.readNumber()>;
    bonerot[r]=<bonefile.readNumber()*(-1),bonefile.readNumber(),bonefile.readNumber()>;
    boneparent[r]=bonefile.readInt();
    }
    monstep(20);
    y=1;
    weights[1]=wmap;
    while(wmap){
    if(wmap.type==VMWEIGHT){weights[y]=wmap;weightnames[y]=wmap.name;}
    y++;
    wmap=wmap.next();
    }    

    writeLine(scmFile,"MODL");
    scmFile.writeInt(5);
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    
    scmFile.writeNumber(0);    

    while(mod(scmFile.offset(),32)!=28){scmFile.writeByte(162);}

    // NAME SECTION ///////////////////////////////////////////////////////

    writeLine(scmFile,"NAME");
    foreach(g,bonenames){
    m=bonenames.indexOf(g);
    nameoffset[m]=scmFile.offset();
    writeLine(scmFile,g);
    scmFile.writeByte(0);
    }    

    while(mod(scmFile.offset(),32)!=28){scmFile.writeByte(162);}

    // BONE SECTION ///////////////////////////////////////////////////////

    writeLine(scmFile,"SKEL");
    boneoff=scmFile.offset();
    foreach (g, bonenames)
    {
    b=bonenames.indexOf(g);
    matrix[4][4]=0;

    matrix=invtrans(bonewpos[b],bonewrot[b]);
    for(y=1;y<=4;y++){for(x=1;x<=4;x++){writeFloat(scmFile,matrix[x,y]);}}
    writeFloat(scmFile,element(bonepos[b],1));
    writeFloat(scmFile,element(bonepos[b],2));
    writeFloat(scmFile,element(bonepos[b],3));
    qbr=quater(rad(element(bonerot[b],1)),rad(element(bonerot[b],2)),rad(element(bonerot[b],3)));
    writeFloat(scmFile,qbr[1]);    
    writeFloat(scmFile,qbr[2]);    
    writeFloat(scmFile,qbr[3]);    
    writeFloat(scmFile,qbr[4]);
    scmFile.writeInt(nameoffset[b]);
    scmFile.writeInt(boneparent[b]+-1);
    scmFile.writeInt(0);
    scmFile.writeInt(0);
    monstep(20);
    }        

    while(mod(scmFile.offset(),32)!=28){scmFile.writeByte(162);}
    mapm=-1;
    mapn=0;
    //VERTEX SECTION /////////////////////////////////////////////////////
    c=0;
    writeLine(scmFile,"VTXL");
    vertoff=scmFile.offset();
    n=0;
    foreach(i, points){             
        point[i]=n;
        n++;
        
    nearfaces=0;
    nearfaces=i.polygon();
    norm=<0,0,0>;
    tangent=<0,0,0>;
    binormal=<0,0,0>;

    foreach(j, nearfaces){
    if(j.pointCount!=3){error("Only triangle faces supported!");}
    norm+=polynormal(j);
    p1=<0,0,0>;
    p2=<0,0,0>;
    p3=<0,0,0>;
    uv1=0;
    uv2=0;
    uv3=0;
    edge1=<0,0,0>;
    edge2=<0,0,0>;
    edgeuv1=0;
    edgeuv2=0;
    cp=0;
    p1=<j.points[1].x, j.points[1].y, j.points[1].z>;
    p2=<j.points[2].x, j.points[2].y, j.points[2].z>;
    p3=<j.points[3].x, j.points[3].y, j.points[3].z>;
    uv1[1]=tmap.getValue(j.points[1],1);
    uv1[2]=tmap.getValue(j.points[1],2);
    uv2[1]=tmap.getValue(j.points[2],1);
    uv2[2]=tmap.getValue(j.points[2],2);
    uv3[1]=tmap.getValue(j.points[3],1);
    uv3[2]=tmap.getValue(j.points[3],2);
    edge1=p2-p1;
    edge2=p3-p1;
    edge1uv[1]=uv2[1]-uv1[1];
    edge1uv[2]=uv2[2]-uv1[2];
    edge2uv[1]=uv3[1]-uv1[1];
    edge2uv[2]=uv3[2]-uv1[2];
    cp = ( edge1uv[2] * edge2uv[1] ) - ( edge1uv[1] * edge2uv[2] );
    if ( cp != 0 )
                        {
                        mul=0;
                        mul = 1.0 / cp;
                        tangent=(edge1*edge2uv[2]*(-1)+edge2*edge1uv[2])*mul;
                        binormal=(edge1*edge2uv[1]*(-1)+edge2*edge1uv[1])*mul;
                        }
    }
    tangent=normalize(tangent/i.polygon);
    binormal=normalize(binormal/i.polygon);
    norm=normalize(norm/i.polygon);
    writeFloat(scmFile,i.x);
    writeFloat(scmFile,i.y);
    writeFloat(scmFile,i.z);
    writeFloat(scmFile,element(norm,1));
    writeFloat(scmFile,element(norm,2));
    writeFloat(scmFile,element(norm,3));
    writeFloat(scmFile,element(tangent,1));
    writeFloat(scmFile,element(tangent,2));
    writeFloat(scmFile,element(tangent,3));
    writeFloat(scmFile,element(binormal,1));
    writeFloat(scmFile,element(binormal,2));
    writeFloat(scmFile,element(binormal,3));

    if(tmap.isMapped(i)){
        writeFloat(scmFile,tmap.getValue(i,1));
        writeFloat(scmFile,1+-tmap.getValue(i,2));
    }
    else{writeFloat(scmFile,0.0);writeFloat(scmFile,0.0);}
    writeFloat(scmFile,0.0);
    writeFloat(scmFile,0.0);
    map=-1;
    foreach(e,weights){if(e.isMapped(i)){if(e.getValue(i)){map=bonenames.indexOf(e.name);}}}
    mapm=map;
    if(map<1)
        {
        addpoint(i.x,i.y,i.z);
        editend();
        error("Unmapped vertex!!! Previous was mapped to ",bonenames[mapn],". Vertice ID ",i,". Single vertex planted at location.");    }
    map--;
    scmFile.writeByte(map);
    scmFile.writeByte(0);
    scmFile.writeByte(0);
    scmFile.writeByte(0);
    monstep(10);
    }
    vertcount=n;
    while(mod(scmFile.offset(),32)!=28){scmFile.writeByte(162);}

    // POLYGONS SECTION ///////////////////////////////////////////////////

    writeLine(scmFile,"TRIS");
    faceoff=scmFile.offset();
    n=0;

    foreach (j, polygons)
    {
    n++;
        for(k=j.pointCount;k>0;k--)
        {
        scmFile.writeShort(point[j.points[4-k]]);
        }
    monstep(5);
    }
    facecount=n;

    scmFile.offset(0);
    writeLine(scmFile,"MODL");    //header FOURCC
    scmFile.writeInt(5);            //version
    scmFile.writeInt(boneoff);            //bone data offset
    scmFile.writeInt(wbonecount);            //weighted bone count
    scmFile.writeInt(vertoff);           //vertex data offset
    scmFile.writeInt(0);            //extra vertex data offset
    scmFile.writeInt(vertcount);    //vertex data count
    scmFile.writeInt(faceoff);                //face data offset
    scmFile.writeInt(facecount*3);    //face count * 3
    scmFile.writeInt(0);    //info data offset
    scmFile.writeInt(0);    //info data count
    scmFile.writeInt(bonecount);    //total bone count
    scmFile.close();
    bonefile.close();
    editend();

selmode(USER);
selpolygon(SET);
mirror(X,0);
delete();
selmode(GLOBAL);

}

writeLine: file, string
{
for(m=1;m<=size(string);m++){
file.writeByte(ascii(strsub(string,m,1)));
}
}

element: vector, position
{
val=parse(" ",vector.asStr());
return(number(val[position]));
}

writeFloat: file, float
{
/*Here's where it gets complicated. We need to write the float number as an integer comprised of binary data that would
make a proper float. According to the wiki, here's what we do.
We take the sign, and set the first bit as that - 0 for plus, 1 for minus.
Next we convert the number into binary. The integer part is easy, since the binary function works that.
The fraction part is trickier, but doable - we need to double it to see if we get a 1 or more, and write 1 for that, 
removing the integer for the next cycle, or write 0 otherwise and move on until we either get a 0 remaining
or the size of the binary string with the integer part hits 24. Then we exponentize the result, and write the 8-bit binary of 127+exponent,
then pad the remaining binary string with zeroes to size 23, and write it too. We should get a binary string that, made into an
integer, should write as a perfect float.*/
sign="";
exponent="";
fraction="";
fracts="";
fract="";
intgr="";
if(float>=0){sign="0";}else{sign="1";}
float=abs(float);
fract=frac(float);
intgr=integer(float-fract);
intbin=binary(intgr);
fractbin=fracbin(intbin,fract);
expt=intbin.size()-fractbin.indexOf('1');
if(float==0){expt=-127;}
exponent=binary(expt+127,8);
if(fractbin.indexOf('1')>0){while(strleft(fractbin,1)=="0"){fractbin=strright(fractbin,fractbin.size()+(-1));}}
fraction=strright(fractbin,fractbin.size()+(-1)); //funky coding to reduce leading zeroes, cut one leading "1", and shape the result.
fraction=strleft(fraction,23);
for(i=3;i>=0;i--){
file.writeByte(integer("0b"+strsub(sign+exponent+fraction,(8*i)+1,8)));
}
}

fracbin: bint,float //function for getting the binary representation of the float-point fraction
{
bins=bint;
while(bins.size()<64)
{
v1=float*2;
if(v1>=1){bins+="1";float=frac(v1);}else{bins+="0";float=v1;}
}
return bins; //Returned is the binary representation of the total fraction section of the initial number
}

invtrans: vecpos,vecrot
{
matrix[4][4]=0.0;
mx[4][4]=0;
px=element(vecpos,1)*(-1);
py=element(vecpos,2)*(-1);
pz=element(vecpos,3)*(-1);
ry=rad(element(vecrot,1)*(-1));
rx=rad(element(vecrot,2)*(-1));
rz=rad(element(vecrot,3)*(-1));
pmtx=pmat(px,py,pz);
xmtx=xmat(rx);
ymtx=ymat(ry);
zmtx=zmat(rz);
matrix=pmtx;
matrix=matmult(matrix,zmtx);
matrix=matmult(matrix,ymtx);
matrix=matmult(matrix,xmtx);
for(i=1;i<5;i++){
    for(j=1;j<5;j++){
        mx[j,i]=matrix[i,j];}}
return mx;
}

pmat: x,y,z
{
temp[4][4]=0;
temp[1,1]=1;
temp[1,2]=0;
temp[1,3]=0;
temp[1,4]=0;
temp[2,1]=0;
temp[2,2]=1;
temp[2,3]=0;
temp[2,4]=0;
temp[3,1]=0;
temp[3,2]=0;
temp[3,3]=1;
temp[3,4]=0;
temp[4,1]=x;
temp[4,2]=y;
temp[4,3]=z;
temp[4,4]=1;
return temp;
}

xmat: val
{
temp[4][4]=0;
temp[1,1]=1;
temp[1,2]=0;
temp[1,3]=0;
temp[2,1]=0;
temp[2,2]=cos(val);
temp[2,3]=sin(val);
temp[3,1]=0;
temp[3,2]=sin(val*(-1));
temp[3,3]=cos(val);
temp[1,4]=0;
temp[2,4]=0;
temp[3,4]=0;
temp[4,1]=0;
temp[4,2]=0;
temp[4,3]=0;
temp[4,4]=1;
return temp;
}
ymat: val
{
temp[4][4]=0;
temp[1,1]=cos(val);
temp[1,2]=0;
temp[1,3]=sin(val*(-1));
temp[2,1]=0;
temp[2,2]=1;
temp[2,3]=0;
temp[3,1]=sin(val);
temp[3,2]=0;
temp[3,3]=cos(val);
temp[1,4]=0;
temp[2,4]=0;
temp[3,4]=0;
temp[4,1]=0;
temp[4,2]=0;
temp[4,3]=0;
temp[4,4]=1;
return temp;
}
zmat: val
{
temp[4][4]=0;
temp[1,1]=cos(val);
temp[1,2]=sin(val);
temp[1,3]=0;
temp[2,1]=sin(val*(-1));
temp[2,2]=cos(val);
temp[2,3]=0;
temp[3,1]=0;
temp[3,2]=0;
temp[3,3]=1;
temp[1,4]=0;
temp[2,4]=0;
temp[3,4]=0;
temp[4,1]=0;
temp[4,2]=0;
temp[4,3]=0;
temp[4,4]=1;
return temp;
}


matmult: a, b
{
    temp[4][4]=0;       // temporary matrix for storing result
    for(i=1;i<5;i++){         // transform by columns first
        for (j=1;j<5;j++){
            temp[i,j] = a[i,1]*b[1,j] + a[i,2]*b[2,j] + a[i,3]*b[3,j] + a[i,4]*b[4,j];}}
return temp;
}

getname: file
{
name="";
chr=file.readByte();
while(chr!=0)
{
name=name+chr.asAsc();
chr=file.readByte();
}
return name;
}

quater: h,p,b
{
wxyz[1]=0;
wxyz[2]=0;
wxyz[3]=0;
wxyz[4]=0;
c1 = cos(h / 2);
c2 = cos(p / 2);
c3 = cos(b / 2);
s1 = sin(h / 2);
s2 = sin(p / 2);
s3 = sin(b / 2);
c1c2=c1*c2;
s1s2=s1*s2;
wxyz[1]= c1*c2*c3 +- s1*s2*s3;
wxyz[2]= s1*s2*c3 + c1*c2*s3;
wxyz[3]= s1*c2*c3 + c1*s2*s3;
wxyz[4]= c1*s2*c3 +- s1*c2*s3;
return wxyz;
}
















